import greenfoot.*;


/**
 * Ein einfacher Counter mit grafischer Darstellung auf dem Bildschirm
 * 
 * @author Micheal Klling (siehe Dokumentation)
 * @version 1.0
 */
public class Counter extends Environment
{
    private static final Color transparent = new Color(0,0,0,0);
    private GreenfootImage background;
    private int value;
    private int target;

    /**
     * Erstellt einen neuen Zhler, der auf 0 initialisiert wird.
     */
    public Counter()
    {
        background = getImage();
        value = 0;
        target = 0;
        updateImage();
    }
    
    /**
     * Animiert die Anzeige, um auf den aktuellen Zielwert hoch (oder runter) zu zhlen.
     */
    public void act() 
    {
        if (value < target) {
            value++;
            updateImage();
        }
        else if (value > target) {
            value--;
            updateImage();
        }
    }

    /**
     * Fgt eine neue Punktzahl zum aktuellen Zhlerstand hinzu.
     */
    public void add(int score)
    {
        target += score;
    }

    /**
     * Gibt den aktuellen Zhlerwert zurck.
     */
    public int getValue()
    {
        return value;
    }

    /**
     * Setzt einen neuen Zhlerwert.
     */
    public void setValue(int newValue)
    {
        target = newValue;
        value = newValue;
        updateImage();
    }

    /**
     * Aktualisiert das Bild auf dem Bildschirm, um den aktuellen Wert anzuzeigen.
     */
    private void updateImage()
    {
        GreenfootImage image = new GreenfootImage(background);
        GreenfootImage text = new GreenfootImage("" + value, 22, Color.BLACK, transparent);
        image.drawImage(text, (image.getWidth()-text.getWidth())/2, 
                        (image.getHeight()-text.getHeight())/2);
        setImage(image);
    }
}
