import greenfoot.*;

/**
 * Monster in unserem Spiel, dass den Spieler frisst
 * 
 * @author Friedrich Tempel und Luk Walther
 * 
 */
public class Monster extends Creature
{
        int newMonsterA = 0;
        int newMonsterB = 0;

    public void act()
    {
        move(3);
        randomTurn();
        turnAtWall();
        turnAtEdge();
        if(tryToEatPlayer() == false) {
            tryToEatBonus();
        }
    }

 
    /**
     * Mit einer 10% probability, Drehung nach links oder rechts.
     */
    public void randomTurn()
    {
        if ( Greenfoot.getRandomNumber(100) < 10 )
        {
            turn( Greenfoot.getRandomNumber(40)-20 );
        }        
    }

    /**
     * Checkt, ob das Monster an der Wand ist und dreht sich weg.
     */
    public void turnAtEdge()
    {
        if (atWorldEdge())
        {
            turn(7);
        }
    }

    /**
     * Prft, ob das Monster die Wand sieht.  Wenn ja, dreht er sich um.
     */
    public void turnAtWall()
    {
        if ( isTouching(Wall.class) )
            {
                turn(8);
            }    
    }
    
    /**
     * Check, ob wir den Player sehen. Wenn ja, wird er gegessen.
     */
    public boolean tryToEatPlayer()
    {
        if (canSee(Player.class) )
        {
            eat(Player.class);
            ((MyWorld)getWorld()).endGame();      
            return true;
        }
        return false;
    }

    /**
     * Check, ob das Monster den Bonus sieht. Wenn ja, wird er gegessen.
     */
    public void tryToEatBonus()
    {        
        if (canSee(Bonus.class) )
        {
            newMonsterA = getX();
            newMonsterB = getY();
            eat(Bonus.class);
            createNewMonster();// Einen neuen Zombie an den Bonuskoordinaten erzeugen
            createNewBonus();// Fgt einen neuen Bonus hinzu
        }
    }

    /**
     * Verwandelt den Bonus in ein Monster und lsst das neu entstandene Monster an der Stelle
     * wo der Bonus gegessen wurde.
     */
    private void createNewMonster()
    {
        Greenfoot.playSound("slurp.wav");
        Monster newMonster;
        newMonster = new Monster(); 
        World world;
        world = getWorld();
        world.addObject(newMonster, newMonsterA, newMonsterB);

    }

    /**
     * Erstellt einen neuen Bonus und fgt ihn an einer random location in die Welt ein.
     */
    private void createNewBonus()
    {
        Bonus newBonus;
        newBonus = new Bonus();

        World world;
        world = getWorld();

        int worldWidth = world.getWidth();
        int worldHeight = world.getHeight();

        int xBonus;
        int yBonus;
        if ( Greenfoot.getRandomNumber(100) < 25 )
        {
            xBonus = 1;
            yBonus = Greenfoot.getRandomNumber(world.getHeight());
        }   
        else if ( Greenfoot.getRandomNumber(100) < 50 ){
            xBonus = worldWidth-1;
            yBonus = Greenfoot.getRandomNumber(world.getHeight());
        }       
        else if ( Greenfoot.getRandomNumber(100) < 75 ){
            yBonus = 1;
            xBonus = Greenfoot.getRandomNumber(world.getWidth());
        }
        else{
            yBonus = worldHeight-1;
            xBonus = Greenfoot.getRandomNumber(world.getWidth());
        }                        
        world.addObject(newBonus, xBonus, yBonus);
    }
}