import greenfoot.*;  // imports Actor, World, Greenfoot, GreenfootImage
/**
 * Hier wird das Spielfeld erstellt.
 * 
 * @author Friedrich Tempel und Luk Walther 
 * 
 */
public class MyWorld extends World
{
    private GreenfootSound Hintergrundmusik = new GreenfootSound("AmongUs.mp3");  
    /**
     * Erzeugt eine Welt 
     */
    public MyWorld(){  
        // Erzeugt eine neue Welt mit 640x480 Zellen in einer Gre von 1x1 Pixeln.
        super(640, 480, 1); 
        setBackground(new GreenfootImage("title.jpg"));
        
     
    }  
    /**
     * Spielt die Hintergrundmusik ab 
     */
    public void started(){
        Hintergrundmusik.playLoop(); //spielt die Hintergrundmusik ab
        if (getObjects(null).isEmpty())  
        {  
            setBackground("space1.jpg");  
            prepare();  
        }
    }  
    /**
     * Bereitet die Welt fr den Spielstart vor. Das heit: Erstellen der ersten Objekte und 
     * diese in der Welt einfgen 
     * 
     */
    
    private void prepare()
    {
        //Eine Fanfare ertnt bei Spielstart
        Greenfoot.playSound("fanfare.wav");
        // platziert den Counter in der oberen rechten Ecke
        Counter counter = new Counter();
        addObject(counter, 48, 19);
        //Platziert den Spieler
        Player player = new Player(counter);
        addObject(player, 41, 245);
        
        // Fgt die MOnster (Gegner) auf der Welt hinzu
        Monster monster1 = new Monster();
        addObject(monster1, 422, 128);
        Monster monster2 = new Monster();
        addObject(monster2, 205, 397);
        Monster monster3 = new Monster();
        addObject(monster3, 70, 83);
        Bonus bonus = new Bonus();
        addObject(bonus, 609, 451);

        // Platziert die Wnde auf der Welt
        Wall wall0 = new Wall();
        addObject(wall0, 332, 168);
        Wall wall1 = new Wall();
        addObject(wall1, 364, 168);
        Wall wall2 = new Wall();
        addObject(wall2, 396, 168);
        Wall wall3 = new Wall();
        addObject(wall3, 332, 200);
        Wall wall4 = new Wall();
        addObject(wall4, 300, 200);
        Wall wall5 = new Wall();
        addObject(wall5, 396, 232);
        Wall wall6 = new Wall();
        addObject(wall6, 364, 232);
        Wall wall7 = new Wall();
        addObject(wall7, 332, 232);
        Wall wall8 = new Wall();
        addObject(wall8, 300, 232);
        Wall wall9 = new Wall();
        addObject(wall9, 396, 264);
        Wall wall10 = new Wall();
        addObject(wall10, 364, 264);
        Wall wall11 = new Wall();
        addObject(wall11, 332, 264);
        Wall wall12 = new Wall();
        addObject(wall12, 300, 264);
        Wall wall13 = new Wall();
        addObject(wall13, 396, 296);
        Wall wall14 = new Wall();
        addObject(wall14, 364, 296);
        Wall wall15 = new Wall();
        addObject(wall15, 332, 296);
        Wall wall16 = new Wall();
        addObject(wall16, 396, 328);
        Wall wall17 = new Wall();
        addObject(wall17, 332, 328);
        
        
        // PLatziert Food (Wasserflaschen)  auf der Welt
        Food food1 = new Food();
        addObject(food1, 160, 120);
        Food food2 = new Food();
        addObject(food2, 480, 120);
        Food food3 = new Food();
        addObject(food3, 160, 360);
        Food food4 = new Food();
        addObject(food4, 480, 360);
    }
    /**
     * Wenn ein Gegner den Spieler isst, wird diese Methode aufgerufen.
     * Sie beendet das Spiel, indem alle Elemente entfernt werden, der Gameover-Screen erscheint
     * und der Game-over-Sound ertnt
     */
    public void endGame()
    {
        removeObjects(getObjects(null));
        setBackground(new GreenfootImage("gameover.jpg"));  
        Hintergrundmusik.stop();
        Greenfoot.playSound("game-over.wav");
        Greenfoot.stop();
    }
    
}