import greenfoot.*; 
/**
 * 
 * Player in unserem Spiel, der vom Spieler gesteuert werden kann
 * @author Friedrich Tempel und Luk Walther
 * 
 */
// Dies ist der Spieler in unserem Spiel.
public class Player extends Creature
{
    private int points = 0;
    private Counter counter;
    int moveSpeed = 0;

    public void act()
    {
        tryToEat();
        checkKeys();
    }

    public Player (Counter pointCounter) 
    {
        counter = pointCounter;
    }

    /**
     * Prft, ob die Steuerungstasten (Pfeiltasten) gedrckt werden.
     * Der Player bewegt sich dementsprechend.
     */
     public void checkKeys()
    {   moveSpeed = 4;
        int x = getX();
        int y = getY();
        setImage ("Player.png");
        if ( Greenfoot.isKeyDown("right") ) {
            setLocation(x + moveSpeed, y);
            if ( isTouching(Wall.class) )
            {setLocation(x - moveSpeed, y);}   
        }
        if ( Greenfoot.isKeyDown("left") ) {
            setLocation(x - moveSpeed, y);
            if ( isTouching(Wall.class) )
            {setLocation(x + moveSpeed, y);}     
        }
        if ( Greenfoot.isKeyDown("up") ) {
            setLocation(x, y - moveSpeed);
            if ( isTouching(Wall.class) )
            {setLocation(x, y + moveSpeed);} 
        }
        if ( Greenfoot.isKeyDown("down") ) {
            setLocation(x, y + moveSpeed);
            if ( isTouching(Wall.class) )
            {setLocation(x, y - moveSpeed);}    
        }
    }

    /** 
     *  Prft, ob der Bonus oder Food gegessen werden knnen und tut dies, wenn mglich.
     */
    public void tryToEat()
    {
        if (canSee(Food.class) )
        {
            eat(Food.class);
            counter.add(5);
            Greenfoot.playSound("heartbeat.wav");
        }

        if (canSee(Bonus.class) )
        {
            eat(Bonus.class);
            counter.add(20);
            Greenfoot.playSound("ominous.wav");
            createNewBonus();
        }
    }

    /**
     * Erstellt einen neuen Bonus und fgt ihn an einer random location in die Welt ein.
     */
    private void createNewBonus()
    {
        Bonus newBonus;
        newBonus = new Bonus();

        World world;
        world = getWorld();

        int worldWidth = world.getWidth();
        int worldHeight = world.getHeight();

        int xBonus;
        int yBonus;
        if ( Greenfoot.getRandomNumber(100) < 25 )
        {
            xBonus = 1;
            yBonus = Greenfoot.getRandomNumber(world.getHeight()); 
        }   
        else if ( Greenfoot.getRandomNumber(100) < 50 ){
            xBonus = worldWidth-1;
            yBonus = Greenfoot.getRandomNumber(world.getHeight());
        }       
        else if ( Greenfoot.getRandomNumber(100) < 75 ){
            yBonus = 1;
            xBonus = Greenfoot.getRandomNumber(world.getWidth());
        }
        else{
            yBonus = worldHeight-1;
            xBonus = Greenfoot.getRandomNumber(world.getWidth());
        }                        
        world.addObject(newBonus, xBonus, yBonus);
    }
}
